VTK: vtkOpenGLCellGridRenderRequest Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkOpenGLCellGridRenderRequest Class Reference

State used by vtkOpenGLCellGridMapper during rendering. More...

`#include <vtkOpenGLCellGridRenderRequest.h>`

Inheritance diagram for vtkOpenGLCellGridRenderRequest:
[legend]
Collaboration diagram for vtkOpenGLCellGridRenderRequest:
[legend]

## Classes
class | StateBase
| An empty base class that responders should inherit to store state using GetState<Subclass>(). More...

## Public Types
enum | RenderableGeometry : unsigned char { VERTICES = 1 , EDGES = 2 , FACES = 4 , VOLUMES = 8 , SURFACE_WITH_EDGES = EDGES | FACES , ALL = VERTICES | EDGES | FACES | VOLUMES }
| An enumeration of which shapes to render. More...
typedef vtkCellGridQuery | Superclass
Public Types inherited from vtkCellGridQuery
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkOpenGLCellGridRenderRequest * | NewInstance () const
void | PrintSelf (std::ostream &os, vtkIndent indent) override
virtual void | SetMapper (vtkOpenGLCellGridMapper *mapper)
| Set/get the mapper which owns this request (so responders can inspect its configuration). More...
virtual vtkOpenGLCellGridMapper * | GetMapper ()
virtual void | SetActor (vtkActor *actor)
| Set/get the actor which responders should use to draw cells. More...
virtual vtkActor * | GetActor ()
virtual void | SetRenderer (vtkRenderer *renderer)
| Set/get the renderer responders should use to draw cells. More...
virtual vtkRenderer * | GetRenderer ()
virtual void | SetWindow (vtkWindow *window)
| Set/get a window (used when IsReleasingResources is true). More...
virtual vtkWindow * | GetWindow ()
virtual char | GetShapesToDraw ()
| Set/get what geometric data to draw for each cell. More...
virtual void | SetShapesToDraw (char)
void | Initialize () override
| This is invoked before processing any cell types during a render. More...
void | Finalize () override
| This is invoked after processing all cell types during a render. More...
virtual bool | GetIsReleasingResources ()
| Set/get whether the request should render (false) or release resources (true). More...
virtual void | SetIsReleasingResources (bool)
template<typename StateType >
StateType * | GetState (vtkStringToken cellType)
| Return a state object of the given type. More...
Public Member Functions inherited from vtkCellGridQuery
vtkCellGridQuery * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLCellGridRenderRequest * | SafeDownCast (vtkObjectBase *o)
static vtkOpenGLCellGridRenderRequest * | New ()
Static Public Member Functions inherited from vtkCellGridQuery
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCellGridQuery * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkOpenGLCellGridRenderRequest ()
| ~vtkOpenGLCellGridRenderRequest () override
Protected Member Functions inherited from vtkCellGridQuery
| vtkCellGridQuery ()=default
| ~vtkCellGridQuery () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkOpenGLCellGridMapper * | Mapper { nullptr }
vtkActor * | Actor { nullptr }
vtkRenderer * | Renderer { nullptr }
vtkWindow * | Window { nullptr }
bool | IsReleasingResources { false }
char | ShapesToDraw { RenderableGeometry::ALL }
std::unordered_map< vtkStringToken, std::unique_ptr< StateBase > > | State
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

State used by vtkOpenGLCellGridMapper during rendering.

This is a vtkCellGridQuery subclass that mappers can use to draw cells into a renderer using an actor and, subsequently, to release resources.

Note that this request has two modes: it will either instruct responders to draw cells (IsReleasingResources == false) or instruct responders to release OpenGL objects for a particular window (when IsReleasingResources == true). Responders must call GetIsReleasingResources() and only perform one task or the other, depending on the returned value.

Definition at line 33 of file vtkOpenGLCellGridRenderRequest.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkCellGridQuery vtkOpenGLCellGridRenderRequest::Superclass

Definition at line 65 of file vtkOpenGLCellGridRenderRequest.h.

## Member Enumeration Documentation

## ◆ RenderableGeometry

enum vtkOpenGLCellGridRenderRequest::RenderableGeometry : unsigned char

An enumeration of which shapes to render.

A cell may be represented by its interior and/or its boundaries of any dimension. These enumerants indicate the dimension of shape to render as a representation of the cell.

The default is to render the cell's shape itself (if possible) and any sides for which arrays exist. Note that the cell-grid mapper does not currently support volume rendering, so VOLUME is ignored; if you wish to render volumetric cells, you must run the vtkCellGridExtractSurface filter to generate side-set arrays for boundaries of interest.

Enumerator
VERTICES |
EDGES |
FACES |
VOLUMES |
SURFACE_WITH_EDGES |
ALL |

Definition at line 55 of file vtkOpenGLCellGridRenderRequest.h.

## Constructor & Destructor Documentation

## ◆ vtkOpenGLCellGridRenderRequest()

vtkOpenGLCellGridRenderRequest::vtkOpenGLCellGridRenderRequest | ( |  | ) |
| protected

## ◆ ~vtkOpenGLCellGridRenderRequest()

vtkOpenGLCellGridRenderRequest::~vtkOpenGLCellGridRenderRequest | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkOpenGLCellGridRenderRequest::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkOpenGLCellGridRenderRequest::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkCellGridQuery.

## ◆ SafeDownCast()

static vtkOpenGLCellGridRenderRequest* vtkOpenGLCellGridRenderRequest::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOpenGLCellGridRenderRequest::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkCellGridQuery.

## ◆ NewInstance()

vtkOpenGLCellGridRenderRequest* vtkOpenGLCellGridRenderRequest::NewInstance | ( |  | ) | const

## ◆ New()

static vtkOpenGLCellGridRenderRequest* vtkOpenGLCellGridRenderRequest::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkOpenGLCellGridRenderRequest::PrintSelf | ( | std::ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override

## ◆ SetMapper()

virtual void vtkOpenGLCellGridRenderRequest::SetMapper | ( | vtkOpenGLCellGridMapper * | mapper | ) |
| virtual

Set/get the mapper which owns this request (so responders can inspect its configuration).

Note that the render request does NOT increase the reference count of the mapper (thus it does not take ownership). This is because the request is owned by the mapper and we do not want to create a reference loop.

## ◆ GetMapper()

virtual vtkOpenGLCellGridMapper* vtkOpenGLCellGridRenderRequest::GetMapper | ( |  | ) |
| virtual

## ◆ SetActor()

virtual void vtkOpenGLCellGridRenderRequest::SetActor | ( | vtkActor * | actor | ) |
| virtual

Set/get the actor which responders should use to draw cells.

Note that the render request does NOT increase the reference count of the actor (thus it does not take ownership). This is to avoid creating a reference loop.

## ◆ GetActor()

virtual vtkActor* vtkOpenGLCellGridRenderRequest::GetActor | ( |  | ) |
| virtual

## ◆ SetRenderer()

virtual void vtkOpenGLCellGridRenderRequest::SetRenderer | ( | vtkRenderer * | renderer | ) |
| virtual

Set/get the renderer responders should use to draw cells.

Note that the render request does NOT increase the reference count of the renderer (thus it does not take ownership). This is to avoid creating a reference loop.

## ◆ GetRenderer()

virtual vtkRenderer* vtkOpenGLCellGridRenderRequest::GetRenderer | ( |  | ) |
| virtual

## ◆ SetWindow()

virtual void vtkOpenGLCellGridRenderRequest::SetWindow | ( | vtkWindow * | window | ) |
| virtual

Set/get a window (used when IsReleasingResources is true).

Note that the render request does NOT increase the reference count of the window (thus it does not take ownership). This is to avoid creating a reference loop.

## ◆ GetWindow()

virtual vtkWindow* vtkOpenGLCellGridRenderRequest::GetWindow | ( |  | ) |
| virtual

## ◆ GetShapesToDraw()

virtual char vtkOpenGLCellGridRenderRequest::GetShapesToDraw | ( |  | ) |
| virtual

Set/get what geometric data to draw for each cell.

The DEFAULT is currently equivalent to ALL. Note that any combination of RenderableGeometry enumerants is accepted.

See also
  RenderableGeometry

## ◆ SetShapesToDraw()

virtual void vtkOpenGLCellGridRenderRequest::SetShapesToDraw | ( | char |  | ) |
| virtual

## ◆ Initialize()

void vtkOpenGLCellGridRenderRequest::Initialize | ( |  | ) |
| overridevirtual

This is invoked before processing any cell types during a render.

Reimplemented from vtkCellGridQuery.

## ◆ Finalize()

void vtkOpenGLCellGridRenderRequest::Finalize | ( |  | ) |
| overridevirtual

This is invoked after processing all cell types during a render.

Reimplemented from vtkCellGridQuery.

## ◆ GetIsReleasingResources()

virtual bool vtkOpenGLCellGridRenderRequest::GetIsReleasingResources | ( |  | ) |
| virtual

Set/get whether the request should render (false) or release resources (true).

The latter should be performed as a separate query after rendering.

Note that after a successful call to Query with IsReleasingResources set to true, the Finalize() method will reset IsReleasingResources to false, which results in the request being marked modified.

## ◆ SetIsReleasingResources()

virtual void vtkOpenGLCellGridRenderRequest::SetIsReleasingResources | ( | bool |  | ) |
| virtual

## ◆ GetState()

template<typename StateType >

StateType* vtkOpenGLCellGridRenderRequest::GetState | ( | vtkStringToken | cellType | ) |
| inline

Return a state object of the given type.

This method is intended for responders to store data with the request.

Definition at line 132 of file vtkOpenGLCellGridRenderRequest.h.

## Member Data Documentation

## ◆ Mapper

vtkOpenGLCellGridMapper* vtkOpenGLCellGridRenderRequest::Mapper { nullptr }
| protected

Definition at line 147 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ Actor

vtkActor* vtkOpenGLCellGridRenderRequest::Actor { nullptr }
| protected

Definition at line 148 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ Renderer

vtkRenderer* vtkOpenGLCellGridRenderRequest::Renderer { nullptr }
| protected

Definition at line 149 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ Window

vtkWindow* vtkOpenGLCellGridRenderRequest::Window { nullptr }
| protected

Definition at line 150 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ IsReleasingResources

bool vtkOpenGLCellGridRenderRequest::IsReleasingResources { false }
| protected

Definition at line 151 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ ShapesToDraw

char vtkOpenGLCellGridRenderRequest::ShapesToDraw { RenderableGeometry::ALL }
| protected

Definition at line 152 of file vtkOpenGLCellGridRenderRequest.h.

## ◆ State

std::unordered_map<vtkStringToken, std::unique_ptr<StateBase> > vtkOpenGLCellGridRenderRequest::State
| protected

Definition at line 153 of file vtkOpenGLCellGridRenderRequest.h.

The documentation for this class was generated from the following file:

- Rendering/CellGrid/vtkOpenGLCellGridRenderRequest.h